
//
/*
<!-- Creative Commons Licence -->
<!-- ©2005 Ciro Mondueri | mondueri.com.
<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/"><img alt="Creative Commons Licence" border="0" src="http://creativecommons.org/images/public/somerights20.gif" /></a><br />
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/">Creative Commons License</a>.
-->
<!-- /Creative Commons Licence -->

<!--
<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:title>DashNub</dc:title>
   <dc:date>2005</dc:date>
   <dc:description>A Mac OS X Tiger Widget to access yubnub.org</dc:description>
   <dc:creator><Agent>
      <dc:title>Ciro Mondueri</dc:title>
   </Agent></dc:creator>
   <dc:rights><Agent>
      <dc:title>Ciro Mondueri</dc:title>
   </Agent></dc:rights>
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Interactive" />
   <dc:source rdf:resource="http://www.mondueri.com/widgets/dashnub"/>
   <license rdf:resource="http://creativecommons.org/licenses/by-nc-sa/2.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by-nc-sa/2.0/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
   <requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
</License>

</rdf:RDF>
-->
*/

var q = "";
var url = "http://www.yubnub.org/parser/parse?command=";
var xurl = "http://www.yubnub.org./all_golden_eggs.xml";
//var xurl = "file:///Users/ciro/Library/Widgets/DashNub.wdgt/golden_eggs.xml";
var manUrlOpen  = "javascript:widget.openURL('http://www.yubnub.org/kernel/man?args=";
var manUrlClose = "')";

var req = null;  /* xhtml request */
var maxDescLength = 120;
var xmlReady = false;
var xmlLoadTime = 0; 
var xmlLoadTimeout = 15 * 60 * 1000;  /* reload golden eggs every 15 minutes */

var debugEnabled = 0;

var wTotal  = 299;
var hSearch = 34;
var listCount = 4;
var hList   = (listCount * 40) + 10;
var hBottom = 18;
var hTotal  = hSearch + hList + hBottom;

function suggestCommand() {
    if (document.getElementById("search").value != null ) {
        if (debugEnabled == 1)
            printMessage(document.getElementById("search").value);
        suggest();
    } else {
        alert("sale por null");
        //printMessage(null);
    }
}

function reloadXML() {    
    // si estoy procesando un request, o si no precisa recargar, no hago nada
    if (window.XMLHttpRequest) {
        if ( (req != null) &&  (req.readyState != 4))  {
            // estoy procesando.. no hacer nada
            return ;            
        } else if ( (req == null ) || ( (xmlLoadTime+xmlLoadTimeout) < (new Date()).getTime() ) ) {
            xmlReady = false;
            try {
                req = new XMLHttpRequest();
            } catch (e) {
                req = false;
            }
            if (req) {
                req.onreadystatechange = reloadXMLCallback;
                req.setRequestHeader("If-Modified-Since", "Wed, 15 Nov 1995 00:00:00 GMT");
                req.setRequestHeader("Cache-Control","no-cache");
                req.open("GET", xurl, true); /* true for async */
                req.send();
                //reloadXMLCallback();
                if (debugEnabled == 1)
                    printMessage("entre a buscar");
            } else {
                if (debugEnabled)
                    printMessage("no tengo xmlhttprequest?");
            }
        }
    } else {
        if (debugEnabled)
            printMessage("no tengo xmlhttprequest?");
    }
}

function reloadXMLCallback() {
    if (debugEnabled)
        printMessage("volvi de la busq");
    if (req.readyState == 4) {
        if ( (req.status == 200) ||  (xurl.substring(0,4) == 'file')) {
            if (debugEnabled == 1)
                printMessage("volvi de la busq");
            xmlLoadTime = (new Date()).getTime();
            xmlReady = true;
            suggest();
            return;
        }
    } 
    if (debugEnabled == 1)
        printMessage("volvi y todo mal:"+req.status);
    xmlReady = false;
}

function xmlNeedsReload() {
    if (xmlReady == false) {
        return true;
    } else if (  (xmlLoadTime+xmlLoadTimeout) < (new Date()).getTime() ) {
        return true ;
    } else {
        return false;
    }
}

function suggest() {
    if (xmlNeedsReload()) {
        //printMessage("reloading");
        reloadXML();
    } else {
        //printMessage("");
        document.getElementById("search").style.color="black";
        try {
            var tMsg = document.getElementById("commandsTable");
            var typed = document.getElementById("search").value;
            //alert("len:"+typed.length);
            if ((typed != null) && (typed.length > 0)) {
                showList();
                tMsg.innerHTML = printCmdsWithDesc(typed);
            } else {
                hideList();
                tMsg.innerHTML = "";
            }
        } catch (e) {
            alert ("Error processing printSuggested: "+e+"\n");
        }
    }
}

function showList() {
    window.resizeTo(wTotal,hTotal);
    document.getElementById("frontSearch").style.backgroundImage = "url(file:images/search_over_paper.png)";
    document.getElementById("frontList").style.display = "block";
    document.getElementById("frontBottom").style.display = "block";
}

function hideList() {
    window.resizeTo(wTotal,hSearch);
    document.getElementById("frontList").style.display = "none";
    document.getElementById("frontBottom").style.display = "none";
    document.getElementById("frontSearch").style.backgroundImage = "url(file:images/search_alone.png)";

}


function printCmdsWithDesc(typed) {
    var omsg = '';
    if (debugEnabled)
        omsg = "<tr><td class='command'/><td >"+(xmlLoadTime+xmlLoadTimeout-((new Date()).getTime()))+"</td></tr>";
    var cmdTitle = '';
    var cmdDesc = '';
    var cmdNode;
    var items = req.responseXML.getElementsByTagName("item");
    var cmdA = new Array();
    var dscA = new Array();
    for (var i=0; i < items.length; i++) {                
        cmdNode = items[i];
        cmdTitle = cmdNode.getElementsByTagName("title")[0].firstChild.nodeValue;
        if ((cmdTitle.length >= typed.length) && 
            (cmdTitle.substring(0,typed.length) == typed) ) {
            cmdDesc = cmdNode.getElementsByTagName("description")[0].firstChild.nodeValue;
            if (cmdDesc.length > maxDescLength) {
                cmdDesc = cmdDesc.substring(0,maxDescLength)+" ...";
            }
            cmdA[cmdA.length] = cmdTitle;
            dscA[dscA.length] = cmdDesc;
        }
    }
    cmdA.sort();
    dscA.sort();
    for (var i=0; (i < cmdA.length) && (i < listCount) ; i++) {
        omsg = omsg+"<tr><td class=\"command\"><a href=\""+manUrlOpen+cmdA[i]+manUrlClose+"\">"+cmdA[i]+"</a></td>";
        omsg = omsg+"<td><a href=\""+manUrlOpen+cmdA[i]+manUrlClose+"\">"+dscA[i]+"</td></tr>\n";
    }
    return omsg;
}



function printMessage(msg) {
    var cMsg = document.getElementById("commandsMsg");
    //    if ( cMsg.style.display == "none")
    if (msg != "") {
        showList();
        cMsg.style.display = "block";
        cMsg.innerHTML = msg;
    } else {
        cMsg.style.display = "none";
        cMsg.innerHTML = "";
    }

}

function searchNub(q)
{
    q = encodeURI(q.replace(/[\s]/gi, '+'));
    if (q == "")
	{
            clearSearch();
            printMessage("");
	}
    else
	{
            alert("en searc"+q);
            if (widget)
                widget.openURL(url + q);
	}
}





function init() {
    createGenericButton(document.getElementById('done'), 'done', hidePrefs);
}


function showPrefs()
{

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    window.resizeTo(wTotal,200);

    if (window.widget)
        widget.prepareForTransition("ToBack");
       
    front.style.display="none";
    back.style.display="block";
    exitflip(event);

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  

}

function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (xmlReady) 
        window.resizeTo(wTotal,hTotal);
    else 
        window.resizeTo(wTotal,hSearch);
    
    if (window.widget)
        widget.prepareForTransition("ToFront");
    
    back.style.display="none";
    front.style.display="block";
    
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);

}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
    if (!flipShown)
	{
            if (animation.timer != null)
		{
                    clearInterval (animation.timer);
                    animation.timer  = null;
		}
            
            var starttime = (new Date).getTime() - 13;
            
            animation.duration = 500;
            animation.starttime = starttime;
            animation.firstElement = document.getElementById ('flip');
            animation.timer = setInterval ("animate();", 13);
            animation.from = animation.now;
            animation.to = 1.0;
            animate();
            flipShown = true;
	}
}
function mouseexit (event)
{
    if (flipShown)
	{
            // fade in the info button
            if (animation.timer != null)
		{
                    clearInterval (animation.timer);
                    animation.timer  = null;
		}
            
            var starttime = (new Date).getTime() - 13;
            
            animation.duration = 500;
            animation.starttime = starttime;
            animation.firstElement = document.getElementById ('flip');
            animation.timer = setInterval ("animate();", 13);
            animation.from = animation.now;
            animation.to = 0.0;
            animate();
            flipShown = false;
	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}




function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}
